%%Uses and disclosure to personal representatives

permitted_by_164_502_g(A) :-
  permitted_by_164_502_g_1(A);
  permitted_by_164_502_g_2(A);
  permitted_by_164_502_g_3(A);
  permitted_by_164_502_g_4(A);
  permitted_by_164_502_g_5(A).

permitted_by_164_502_g_1(A) :-
%treat personal representative as individual except by g-3 ang g-5.
  fail.

permitted_by_164_502_g_2(A) :-
% should treat adult or emancipated minor in making decision as individual, 
% relavant to such personal representatives.
  is_about_adult(A),
  msg_about(A, X),
  msg_to(A, Y),
  personal_representative(X, Y).

is_guardian(X, Y) :-
  parent(X, Y);
  guardian(X, Y);
  loco_parentis(X, Y).

permitted_by_164_502_g_3(A) :-
  permitted_by_164_502_g_3_i(A);
  permitted_by_164_502_g_3_ii(A).


permitted_by_164_502_g_3_i(A) :-
% relavant to such personal representatives.
% about health care services
  is_about_minor(A),
  msg_about(A, X),
  msg_to(A, Y),
  is_guardian(X, Y),
  \+ (permitted_by_164_502_g_3_i_A(A),
      permitted_by_164_502_g_3_i_B(A),
      permitted_by_164_502_g_3_i_C(A)).

permitted_by_164_502_g_3_i_A(A) :-
  fail.
  
permitted_by_164_502_g_3_i_B(A) :-
  fail.

permitted_by_164_502_g_3_i_C(A) :-
  fail.

permitted_by_164_502_g_3_ii(A) :-
  permitted_by_164_502_g_3_ii_A(A);
  permitted_by_164_502_g_3_ii_B(A);
  permitted_by_164_502_g_3_ii_C(A).

permitted_by_164_502_g_3_ii_A(A) :-
% covered entity may send to guardian based on applicable law
  fail.

permitted_by_164_502_g_3_ii_B(A) :-
% covered entity may NOT send to guardian based on applicable law
  fail.

permitted_by_164_502_g_3_ii_C(A) :-
% licensed medical practioner may send based on professional judgement
  fail.

permitted_by_164_502_g_4(A) :-
  is_about_deceasedIndividual(A),
  msg_about(A, X),
  msg_to(A, Y),
  personal_representative(X, Y).
  
permitted_by_164_502_g_5(A) :-
  permitted_by_164_502_g_5_i(A);
  permitted_by_164_502_g_5_ii(A).

permitted_by_164_502_g_5_i(A) :-
  msg_about(A, X),
  msg_to(A, Y),
  %is_belief_dangerousRepresentative(X, Y).
  fail.

permitted_by_164_502_g_5_ii(A) :-
  %is_belief_notBestInterestOfIndividual(X, Y).
  fail.
