:- ['HIPAA.pl'].

%%%Scrubs
%%%%%%%%%%%%%%%%%%%%%%%%
%%Roles
%------
%doctor
  %intern
  %surgeon
  %chief_doctor
%nurse
%janitor
%lawyer
%patient

%%%%%%%%%%%%%% Sacred Heart Hospital
%Hospital Organization Structure- could be wrong just for working example
%                                        hospital
%                                            |                         \
%                                        employee                     individual
%                     /                      |        \        \        
%                  doctor                 janitor    lawyer   nurse  
%           /        |         \
%         intern  surgeon  chief_doctor
%%%%%%%%%


%%Entity
%-------
%shh -  sacred Heart Hospital
%jd
%elliot
%turk
%carla
%cox
%kelso
%j
%ted
%alice

%in_role(jd, intern).
%in_role(elliot, intern).
%in_role(turk, surgeon).
%in_role(carla, nurse).
%in_role(cox, doctor).
%in_role(kelso, chief_doctor).
%in_role(j,janitor).
%in_role(ted,lawyer).
%in_role(alice, patient).

inRole(doctor, healthCare_provider).
inRole(nurse, healthCare_provider).
inRole(shh, healthCare_provider).
inRole(test_individual, individual).
inRole(joe, individual).

inRole(test_entity1, healthCare_provider).
inRole(test_entity1, covered_entity).
inRole(test_entity2, covered_entity).
inRole(test_entity3, covered_entity).
inRole(test_entity3, group_health_plan).
inRole(test_associate1, healthCare_provider).


inRole(jd, covered_entity).
inRole(carla, covered_entity).
inRole(lavern, assistant).
inRole(alice, individual).

employee_of(jd, shh).
employee_of(carla, shh).
employee_of(lavern, shh).

%Types of phi

phi(bloodwork).
phi(medical_history).
phi(xrays).
phi(null).

%Purposes of specifics.
purpose( surgery, treatment).

%minimum necessary or less.
minimum( bloodwork, surgery).

%% business_assocate(X,Y):  Y is a business associate of X.
business_associate(datacenter, shh).
business_associate(microsoft_datacenter, shh).
business_associate(test_entity1, test_associate1).

in_relation(joe, jill).


