:- ['SHH.pl'].

%Tests

%%%
%%  Part A
%%%

test :-
  test164_502_a;
  test164_502_b;
  test164_502_c;
  test164_502_d;
  test164_502_e;
  writeln('all done').


test164_502_a :-
  test164_502_a_1_i,
  writeln('Test 164_502_a_i passed'),
  test164_502_a_1_ii,
  writeln('Test 164_502_a_ii passed'),
  test164_502_a_1_iii,
  writeln('Test 164_502_a_iii passed').

test164_502_a_1_i :-
  pbh(a(test_individual, test_entity1, test_individual, null, null, null, null)).
  
test164_502_a_1_ii :-
  pbh(a(null, null, null, null, healthCare_operations, null, null)),
  pbh(a(null, null, null, null, payment, null, null)),
  pbh(a(null, null, null, null, treatment, null, null)).
  
test164_502_a_1_iii :-
  pbh(a(null, null, null, null, incident_to_use, null, null)).
  
%Rule not yet implemented.
test164_502_a_1_iv :-
  true.

%Rule not yet implemented.  
test164_502_a_1_v :-
  true.

%Rule not yet implemented. 
test164_502_a_1_vi :-
  true.
  
test164_502_a_2 :-  
  test164_502_a_2_i,
  test164_502_a_2_ii.

%Rule not fully implemented
test164_502_a_2_i :-
   pbh(a(test_individual, test_entity1, test_individual2, null, null, b(null, null, null, null, requested_by_Individual, null, null), null)).
  
%Rule not fully implemented.
test164_502_a_2_ii :-
   pbh(b(secretary, test_entity1, test_individual, null, investigate, null, null)).
   
%%%
%%  Part B
%%%

test164_502_b :- 
  test164_502_b_1,
  output('Test 164_502_b_1 passed'),
  test164_502_b_2,
  output('Test 164_502_b_2 passed').

test164_502_b_1 :- 
   pbh(a(test_entity1, test_entity2, test_individual, bloodwork, surgery, null, null )),
   not(pbh(a(test_entity1, test_entity2, test_individual, bloodwork, nothing, null, null ))).
   
test164_502_b_2 :-   
  test164_502_b_2_i,
  output('Test 164_502_b_2_i passed'),
   test164_502_b_2_ii,
  output('Test 164_502_b_2_ii passed'),
   test164_502_b_2_iii,
  output('Test 164_502_b_2_iii passed'),
   test164_502_b_2_iv,
  output('Test 164_502_b_2_iv passed'),
   test164_502_b_2_v,
  output('Test 164_502_b_2_v passed'),
   test164_502_b_2_vi,
  output('Test 164_502_b_2_vi passed').
   
test164_502_b_2_i :-
  pbh(a(test_entity1, test_entity2, test_individual, phi, treatment, null, null )).
  
test164_502_b_2_ii :-
  pbh(a(test_individual, test_entity1, test_individual, anything, anything, null, null)).

%160 not implemented.
test164_502_b_2_iii :-
  pbh(a(anybody, anybody, anybody, anything, authorized, null, null)).
  
test164_502_b_2_iv :-
  pbh(a(secretary, test_entity1, test_individual, anything, investigation, null, null)).

%Does not work for now.
test164_502_b_2_v :-
  pbh(a(anybody, test_entity1, test_individual, anything, anything, required_by_law, null, null )).
 
test164_502_b_2_vi :-
  pbh(a(anybody, test_entity1, test_individual, anything, anything)).

%%%
%%  Part C
%%%

%Not completely implemented  
test164_502_c :-
  true.
  
%%%
%%  Part D
%%%  

test164_502_d :-
  (test164_502_d_1;
  writeln('Test 164_502_d_1 passed')),
  (test164_502_d_2;
  writeln('Test 164_502_d_2 passed')).
  
test164_502_d_1 :-
  pbh(a(test_associate1, test_entity1, test_individual, phi, create_deidentified_info, null, null )).


%Not implemented yet  
test164_502_d_2 :-
  true.
  
%%%
%%  Part E
%%%  

test164_502_e :-
  test164_502_e_1_i,
  writeln('Test 164_502_e_1_i passed'),
  test164_502_e_1_ii,
  writeln('Test 164_502_e_1_ii passed').

test164_502_e_1_i :-
  pbh(a(test_associate1, test_entity1, test_individual, phi, create_protected_health_info, null, null)),
  pbh(a(test_associate1, test_entity1, test_individual, phi, receive_protected_health_info, null, null)).
  
test164_502_e_ii :-
  test164_502_e_ii_A,
  test164_502_e_ii_B,
  test164_502_e_ii_C.

%Surprise still allowed.  Redundant rule?
test164_502_e_ii_A :-
  not(pbh(a(test_associate1, test_entity1, test_individual, phi, treatment, null, null))).

%Not complete  
test164_502_e_ii_B :-
  not(pbh(a(test_associate1, test_entity3, test_individual, phi, treatment, null, null))).

%Not complete
test164_502_e_ii_C :-
  not(pbh(a(test_associate1, test_entity1, test_individual, phi, treatment, null, null))).
  
output(A) :-
  writeln(A),
  true.
  
  
